/*  computePmode4ByteAddress.c
    By Pierre Sarrazin <http://sarrazip.com/>
    This file is in the public domain.
*/

#include "Primitive.h"


const byte bgraph_resetMasks[8] = { 0x80, 0x40, 0x20, 0x10, 8, 4, 2, 1 };


// Input: Register A = vert. coord. (0..191),
//                 B = horiz. coord. (0..255).
//                 X => PMODE 4 buffer.
// Output: X => Byte targeted by the input coordinates.
//         Trashes A and B.
//
asm void bgraph_computePmode4ByteAddress(void)
{
    asm
    {
        lsrb
        lsrb
        lsrb                            ; B = (x >> 3)
        pshs    b
;
        clrb                            ; D = ((word) y << 8)
        lsra                            ; shift D right 3 times
        rorb
        lsra
        rorb
        lsra
        rorb                            ; D = (word) y << 5)
;
        addb    ,s+
        adca    #0                      ; D = offset into the 6k buffer
        leax    d,x                     ; X => byte to change
    }
}
