/*  setPixelPmode4.c
    By Pierre Sarrazin <http://sarrazip.com/>
    This file is in the public domain.
*/

#include "Primitive.h"

extern const byte bgraph_resetMasks[8];

void bgraph_computePmode4ByteAddress(void);


void
Primitive_setPixelPmode4(word x, byte y, byte color, void *pmode4Buffer)
{
    #if 0  /* Original C code. */
    byte shiftCount = (7 - ((byte) x & 7));
    byte resetMask = (byte) 1 << shiftCount;
    byte colorMask = color << shiftCount;
    byte *byteToChange = ((byte *) pmode4Buffer) + ((word) y << 5) + ((byte) x >> 3);
    *byteToChange = *byteToChange & ~resetMask | colorMask;
    #else
    byte shiftCount, resetMask, colorMask;
    asm
    {
        ldb     :x[1]                   ; high byte of 'x' ignored
        andb    #7
        leax    :bgraph_resetMasks
        lda     b,x                     ; A = resetMasks[shiftCount] = 1 << shiftCount = resetMask
        sta     :resetMask
;
        tst     :color
        beq     @colorIsBlack
        sta     :colorMask              ; colorMask = resetMask b/c color is not black
        bra     @colorMaskComputed
@colorIsBlack
        clr     :colorMask
@colorMaskComputed
        ldb     :x[1]
        lda     :y                      ; no need for [1] as with :x, because 'y' is declared as byte
        ldx     :pmode4Buffer
        lbsr    bgraph_computePmode4ByteAddress     ; byteToChange in X
; *byteToChange = *byteToChange & ~resetMask | colorMask;
        com     :resetMask
        ldb     ,x
        andb    :resetMask
        orb     :colorMask
        stb     ,x
    }
    #endif
}
